/* -*- mode: c++; c-basic-offset: 4; indent-tabs-mode: nil -*-

   this file is part of rcssserver3D
   Fri May 9 2003
   Copyright (C) 2002,2003 Koblenz University
   Copyright (C) 2003 RoboCup Soccer Server 3D Maintenance Group
   $Id: export.cpp,v 1.4 2004/05/07 17:11:28 markelic Exp $

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; version 2 of the License.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <zeitgeist/zeitgeist.h>
#include "createeffector/createeffector.h"
#include "driveeffector/driveeffector.h"
#include "beameffector/beameffector.h"
#include "kickeffector/kickeffector.h"
#include "sayeffector/sayeffector.h"
#include "initeffector/initeffector.h"
#include "soccercontrolaspect/soccercontrolaspect.h"
#include "gamestateaspect/gamestateaspect.h"
#include "ballstateaspect/ballstateaspect.h"
#include "soccerruleaspect/soccerruleaspect.h"
#include "agentstate/agentstate.h"
#include "sexpmonitor/sexpmonitor.h"
#include "trainercommandparser/trainercommandparser.h"
#include "fieldflag/fieldflag.h"
#include "ball/ball.h"
#include "visionperceptor/visionperceptor.h"
#include "gamestateperceptor/gamestateperceptor.h"
#include "agentstateperceptor/agentstateperceptor.h"

ZEITGEIST_EXPORT_BEGIN()
        ZEITGEIST_EXPORT(SoccerControlAspect);
        ZEITGEIST_EXPORT(GameStateAspect);
        ZEITGEIST_EXPORT(BallStateAspect);
        ZEITGEIST_EXPORT(SoccerRuleAspect);
        ZEITGEIST_EXPORT(CreateEffector);
        ZEITGEIST_EXPORT(DriveEffector);
        ZEITGEIST_EXPORT(BeamEffector);
        ZEITGEIST_EXPORT(KickEffector);
        ZEITGEIST_EXPORT(SayEffector);
        ZEITGEIST_EXPORT(InitEffector);
        ZEITGEIST_EXPORT(ObjectState);
        ZEITGEIST_EXPORT(AgentState);
        ZEITGEIST_EXPORT(TrainerCommandParser);                
        ZEITGEIST_EXPORT(SexpMonitor);
        ZEITGEIST_EXPORT(FieldFlag);
        ZEITGEIST_EXPORT(Ball);
        ZEITGEIST_EXPORT(VisionPerceptor);
        ZEITGEIST_EXPORT(GameStatePerceptor);
        ZEITGEIST_EXPORT(AgentStatePerceptor);
ZEITGEIST_EXPORT_END()

